// glow filter pixel shader

#ifdef GL_ES
precision mediump float;
#endif

#ifdef GL_ES
varying lowp vec4 v_fragmentColor;
varying mediump vec2 v_texCoord;
varying lowp vec4 v_offset_color;
#else
varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
varying vec4 v_offset_color;
#endif

uniform sampler2D CC_Texture0;
uniform float u_addHue;
uniform float u_addSat;
uniform float u_addLig;
uniform vec4 u_offsetColor;

float Hue_2_RGB(float v1, float v2, float vH )
{
	float ret;
	if ( vH < 0.0 )
		vH += 1.0;
	if ( vH > 1.0 )
		vH -= 1.0;
	if ( ( 6.0 * vH ) < 1.0 )
		ret = ( v1 + ( v2 - v1 ) * 6.0 * vH );
	else if ( ( 2.0 * vH ) < 1.0 )
		ret = ( v2 );
	else if ( ( 3.0 * vH ) < 2.0 )
		ret = ( v1 + ( v2 - v1 ) * ( ( 2.0 / 3.0 ) - vH ) * 6.0 );
	else
		ret = v1;		
   return ret;
}

void main()
{
	vec4 _sample_color = texture2D(CC_Texture0, v_texCoord);
 
    gl_FragColor = v_fragmentColor * _sample_color + v_offset_color + u_offsetColor;

}
