// glow filter pixel shader

#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
varying vec4 v_offset_color;
varying vec4 v_screenPosition;

uniform sampler2D CC_Texture0;
uniform float u_maskScreenMinY;
uniform float u_maskScreenMaxY;

void main()
{
	if (v_screenPosition.y <= u_maskScreenMinY || v_screenPosition.y >= u_maskScreenMaxY )
		discard;
	
	vec4 _sample_color = texture2D(CC_Texture0, v_texCoord);
	if (_sample_color.x == 0.0 && _sample_color.y == 0.0 && _sample_color.z == 0.0 && _sample_color.w == 0.0)
	{
		gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
	}
    else
	{
        gl_FragColor = v_fragmentColor * _sample_color + v_offset_color;
	}
	
}
