
--[[
	@伤害公式: 			攻击者攻击力*(1-防御/(防御+攻击者等级*20+80))
	@dAttack: 			攻击者攻击力
	@iLevel				攻击者等级
	@dHitDefense		受击者防御力
	@dHitDefensePromote	受击者防御提升百分比
]]--
function formula_get_damage(dAttack, dAttackPromote, dHitDefense, dHitDefensePromote, iLevel)
	
--[[	local n1 = dAttack*(1+dAttackPromote)					--攻击者攻击力*(1+攻击者技能伤害加成百分比)
	local n2 = dHitDefense*(1+dHitDefensePromote)			--受击者防御*(1+受击者防御提升百分比)
	local n3 = 100+dHitDefense*(1+dHitDefensePromote)		--(100+受击者防御*(1+受击者防御提升百分比))
	local vaule = n1*(1-n2/n3)
]]--	

	local C = iLevel*20+80
	
	local vaule = dAttack*(1-dHitDefense/(dHitDefense+C))
	return vaule;
end

--[[
	@暴击伤害公式: 		伤害*2
	@dAttackVaule: 		攻击伤害(formula_get_damage的计算结果)
]]--
function formula_get_critical_damage(dAttackVaule)
	
	local vaule = dAttackVaule*2.0							--伤害*2

	return vaule
end



--[[
	@暴击率公式: 		(攻击者暴击-受击者抗暴)/10000
	@iAttackCritical: 	攻击者暴击
	@iTargetToughness: 	受击者抗暴
]]--
function formula_get_critical_rate(iAttackCritical, iTargetToughness)
	
	local vaule = (iAttackCritical-iTargetToughness)/10000.0							--(攻击者暴击-受击者抗暴)/10000

	return vaule
end

--[[
	@闪避率公式: 		(攻击者命中-受击者闪避)/10000
	@iAttackerHit: 		攻击者命中
	@iTargetDodge: 		受击者命中
]]--
function formula_get_miss_rate(iAttackerHit, iTargetDodge)
	
	local vaule = (iAttackerHit-iTargetDodge)/10000.0
	return vaule
	
end

--[[
	@技能附加伤害:		damage_m+damage_mup*(技能等级-1)
	@iSkillLev: 		技能等级
	@iDamage_m: 		damage_m
	@iDamage_mup:		damage_mup
]]--
function formula_get_skill_ex_damage(iSkillLev, iDamage_m, iDamage_mup)
	
	local vaule = iDamage_m+iDamage_mup*(iSkillLev-1)
	return vaule
end

--[[
	@技能伤害:		(basedamage/100*ATT+额外技能攻击)*(1-防御/(防御+C))
	@iBaseSkilDamage: 	基础技能伤害
	@dSkillDamageEx: 	技能附加伤害(formula_get_skill_ex_damage的计算结果)
	@dAttackValue:		攻击方基础攻击
	@dHitDefense: 		防御方防御力
	@iLevel: 		    攻击方等级
]]--
function formula_get_skill_damage(iBaseSkilDamage, dSkillDamageEx, dAttackValue, dHitDefense, iLevel)
	
	local skillAddDamage = dSkillDamageEx+dAttackValue
	local C 			 = iLevel*20+80
	local vaule =((iBaseSkilDamage/100)*dAttackValue+dSkillDamageEx)*(1-dHitDefense/(dHitDefense+C))
	return vaule
end


--[[
	@竞技场排名上升获得荣誉:	cell(max(8000*0.995^N*(1-0.995^M), M/10))
	@iN: 						原来名次
	@iM: 						上升了多少名
]]--
function formula_get_honour(iN, iM)
	
	local n1 = math.pow(0.995,iN)
	local n2 = 1-math.pow(0.995,iM)
	local vaule = math.cell(math.max(8000*n1*n2, iM/10))
	return vaule
end

--[[
	@战斗力计算:			   (生命*5+防御*9+攻击*25+技能等级*5)/20
	@dHP: 						血
	@dAttack: 					攻击力
	@dDefence: 					防御力
	@iSkillLev: 				技能等级

]]--
function formula_get_fight_point(dHP, dAttack, dDefence, iSkillLev)

	local vaule =  ((dHP*5)+(dAttack*25)+(dDefence*9)+(iSkillLev*5))/20
	return vaule
end

--[[
	*********************能量回复***************************
]]--

--[[
	@卡牌总能量
]]--
function formula_get_card_total_energy()
	local value = 500
	return value
end

--[[
	@每一波能量回复：		(卡牌回复 + 装备总回复)/10
	@dCardReply:			卡牌回复
	@dEquipReply:			装备总回复
]]--
function formula_get_wave_energy_reply(dCardReply, dEquipReply)
	local value = (dCardReply + dEquipReply)/1
	return value
end

--[[
	@攻击能量回复
]]--
function formula_get_attack_energy_reply()
	local value = 30
	return value
end

--[[
	@受击能量回复:		((伤害*100)/生命总值)*20	
	@dTotalHp:			生命总值
	@dDamage:			伤害值
]]--
function formula_get_damage_energy_reply(dTotalHp, dDamage)
	local value = ((dDamage * 100) / dTotalHp) * 5
	return value
end

--[[
	@受击能量回复(PVP):		((伤害*100)/生命总值)*20	
	@dTotalHp:				生命总值
	@dDamage:				伤害值
	@dLevel:				卡牌等级
]]--
function formula_get_damage_energy_reply_ratio(dTotalHp, dDamage, dLevel)
	local fRatio
	if(dLevel>=1 and dLevel<=30) then
		fRatio = 2
	elseif(dLevel>30 and dLevel<=50) then
		fRatio = 5
	elseif(dLevel>50 and dLevel<=100) then
		fRatio = 8
	else
		fRatio = 0
	end
	local value  = ((dDamage * 100) / dTotalHp) * fRatio
	return value
end

--[[
	@击杀能量回复	
]]--
function formula_get_kill_energy_reply()
	local value = 100
	return value
end

--[[
	@死亡队友能量回复	
]]--
function formula_get_partner_energy_reply()
	local value = 0
	return value
end

--[[
	*********************技能Buffer命中率***************************
]]--

--[[
	@技能buffer命中率:	
	@dSkillLevel:			技能等级
	@dTargetLevel:			目标等级
	@dBaseRate:				基础命中率
]]--

function formula_get_skill_buffer_rate(dSkillLevel, dTargetLevel, dBaseRate)
	local nRate = 0
	if(dSkillLevel<dTargetLevel) then
		nRate = dBaseRate*0.95^(dTargetLevel-dSkillLevel)
	else
		nRate =dBaseRate
	end
	
	return nRate
end




































